/**
 * Hashing
 * 
 * Namen der Mitglieder und Matrikelnummern hier.
 */
public class Hashing {

    /**
     * Status fr Hash-Eintrge.
     * Bitte nicht ndern!
     */
    public static int free = 0, used = 1, deleted = -1;

    /**
     * Einfgen mit doppeltem 
     * Bitte nicht ndern!
     */
    public static int insert1(Hash table[], int k) {
        int numOfCollisions = 0;
        int m = table.length;
        int insertPos = mod(h1(k), m);
        while (table[insertPos].state == used) {
            insertPos = mod(h2(k, m).add(BigInteger.valueOf(insertPos)), m);
            numOfCollisions++;
        }
        table[insertPos].key = k;
        table[insertPos].state = used;
        return numOfCollisions;
    }

    /**
     * Einfgen mit Variante von doppeltem 
     * Hier sind die mit Kommentaren markierten Zeilen zu vervollstndigen!
     */
    public static int insert2(Hash table[], int k) {
        int numOfCollisions = 0;
        int m = table.length;
        int insertPos = mod(h1(k), m);
        while (table[insertPos].state == used) {
            int newNext = mod(h2(k, m).add(BigInteger.valueOf(insertPos)), m);
            int oldNext = mod(h2(table[insertPos].key, m).add(BigInteger.valueOf(insertPos)), m);
            if (table[newNext].state == free || table[oldNext].state == used) {
                insertPos = newNext;
            } else {
                table[oldNext].key = table[insertPos].key;
                table[oldNext].state = used;
                table[insertPos].state = deleted;
            }
            numOfCollisions++;
        }
        table[insertPos].key = k;
        table[insertPos].state = used;
        return numOfCollisions;
    }

    /**
     * Eine Hash-Funktion.
     * Bitte nicht ndern!
     */
    private static BigInteger h1(int key) {
        return BigInteger.valueOf(3).multiply(BigInteger.valueOf(key).pow(2));
    }

    /**
     * Eine Hash-Funktion. Der Wert limit muss eine Primzahl sein.
     * Bitte nicht ndern!
     */
    private static BigInteger h2(int key, int limit) {
        BigInteger res = BigInteger.valueOf(7).multiply(BigInteger.valueOf(key).pow(3)).abs();
        if (res.remainder(BigInteger.valueOf(limit)).compareTo(BigInteger.ZERO) == 0) {
            return BigInteger.ONE;
        }
        return res;
    }

    /**
     * Die modulo Operation.
     * Bitte nicht ndern!
     */
    private static int mod(BigInteger value, int limit) {
        return value.remainder(BigInteger.valueOf(limit)).intValue();
    }

}
